#ifndef LIB_EMITPARSYSTEM_H
#define LIB_EMITPARSYSTEM_H

#include "lib/parsystem.h"

class EmitParticle {
public:
	//system: bidirectional link
	EmitParticle *prev, *next;

	//all else;
	vec4f		c;			//color
	float		radius;		//radius
	float		life;		//how much longer we have to live
	float		baseLife;	//where we started.  used for fadeouts
	Particle	*par;		//Particle within ParSystem
};

class EmitParSystem {
/*
public:
	std::vector<EmitParticle> emitPar;

	int createEmitParticle();
*/
protected:
	void reset();

	int parCount;
	int liveCount;
	EmitParticle *live, *dead;

	//the one dif between this and a ParSystem class
	ParSystem *parSys;

public:
	EmitParSystem() {reset();}
	~EmitParSystem() {shutdown();}

	bool init(ParSystem *parSys);
	void shutdown();

	EmitParticle *createEmitParticle();
	void removeEmitParticle(EmitParticle *p);

	EmitParticle *getLive() { return live; }
	int getLiveCount() { return liveCount; }
	int getTotalCount() { return parCount; }
};


#endif
